.\" Copyright (c) 1997 Mariusz Krawczyk
.\" Uogonkowienie i korekta formatowania: Andrzej Krzysztofowicz
.\" 
.TH CPL 7 "28 sierpnia 1997" "ConvPL"
.SH NAZWA
cpl \- konwerter standardw polskich znakw v2.07
.SH SKADNIA
.B cpl
.I nn
.RI [ konwersja ]
.RB [ - ]
.RI [ plik1.txt ]
.RI [ plik2.txt " ... ]"

.SH OPIS
Parametr
.RB nn
to dwie cyfry/litery, okrelajce standard 
.I rdowy 
(pierwsza) i 
.I docelowy 
(druga) przeprowadzanej konwersji.
Parametr
.B konwersja
okrela rodzaj opcjonalnie stosowanej konwersji
zakoczenia linii pomiedzy DOSem a Unixem i Amig.

.SH PRZYKADY
.TP
.B cpl 14 tekst1.txt
\- plik tekst1.txt (Mazovia -> ISO-Latin-2)
.TP
.B cpl 14 *.txt
\- wszystkie pliki z rozszerzeniem .txt
.TP
.B cpl 14 tekst1.txt *.doc
\- plik tekst1.txt i wszystkie .doc

.SH "OBSUGIWANE STANDARDY"
Dostpne standardy (podajemy dwie cyfry/litery):
.TP
.B 0:
bez polskich liter (ASCII, CP473)
.TP
.B 1:
Mazovia
.TP
.B 2:
FidoMazovia
.TP
.B 3:
IBM Latin 2 (CP852)
.TP
.B 4:
ISO Latin 2 (ISO-8859-2)
.TP
.B 5:
DHN
.TP
.B 6:
CSK
.TP
.B 7:
Cyfromat (IINTE-ISIS)
.TP
.B 8:
IEA
.TP
.B 9:
LOGIC
.TP
.B a:
Microvex
.TP
.B b:
Amiga PL
.TP
.B c:
CP/J (Elwro 800 Junior)
.TP
.B d:
Amiga FAT
.TP
.B e:
Windows 3.x/95 (CP1250)
.TP
.B f:
Amiga XJP
.TP
.B g:
Ventura
.TP
.B h:
Macintosh
.TP
.B i:
TeX PL
.TP
.B j:
Corel 2.0
.TP
.B k:
Atari Calamus
.TP
.B l:
FX
.TP
.B m:
KWK
.TP
.B n:
MS Works
.TP
.B o:
ATM

.SH SKRTY
Zamiast najczciej stosowanych konwersji mona stosowa skrty. Podajemy
wwczas tylko jedn liter:
.TP
.B A:
Mazovia na IBM Latin 2
.TP
.B B:
IBM Latin 2 na Mazovi
.TP
.B C:
Mazovia na ASCII
.TP
.B D:
IBM Latin 2 na ASCII
.TP
.B F:
FidoMazovia na Mazovi
.PP
Dowolno konwersji jest cakowita, z jednym wyjtkiem. Standard ASCII nie
moe by standardem rdowym konwersji (przyczyna jest oczywista - eby nie
pokaszani caego tekstu - ale jest od tej reguy wyjtek! patrz
.BR UWAGI ).

.SH "KONWERSJA ZAKOCZE LINII"
.I ConvPL 
umoliwia rwnoleg konwersj pomidzy tekstem spod DOSa, a tekstem
spod Uniksa czy Amigi. Rodzaj docelowej konwersji okrelaj parametry:
.TP
.B \-: 
konwersja do tekstu Uniksa (Amigi)  -> NL
.TP
.B \=: 
konwersja do tekstu DOSa            -> CR+LF
.PP
Zmieniem wystpujce w poprzednich wersjach oznaczenia tych parametrw
(/, \\), poniewa ukonik odwrotny jest znakiem specjalnym pod Uniksami. Nowe
ustawienia mona rwnie atwo zapamita: pod Uniksem koniec linii to jeden
znak (NL), wic jedna kreska: "-"; pod DOSem s to dwa znaki (CR+LF), std
dwie kreski: "=". Logiczne ;)

.SH "PRACA W TRYBIE FILTRU"
.I ConvPL
moe pracowa rwnie w trybie filtru. Podanie znaku "-" zamiast
nazw plikw spowoduje pobranie tekstu ze standardowego urzdzenia wejcia 
- stdin (klawiatura) i zapisanie go do standardowego wyjcia - stdout 
(monitor, terminal, drukarka). Przykady:
.TP
.B cpl A \-
\- kada linia wpisywana z klawiatury bdzie
pojawiaa si poniej po wciniciu
.IR <Enter> ,
znaki z kodu Mazovia bd
zamieniane na IBM Latin 2
.TP
.B cpl 13 <joke.txt >prn
\- konwersja pliku joke.txt i wysanie
wynikw bezporednio na drukark (DOS); czsto sam z tego korzystam, bo na
moim PC pod DOSem mam Mazovi, a na drukarce CP852.
.PP
Jeli nie chcemy zamieca sobie dysku, wydajemy nastepujce polecenia:
.TP
.BR "cpl A - <joke.txt >nul " (MSDOS)
lub 
.B >/dev/null
(Unix) ;)))
.PP
Tryb filtru umoliwia rwnie przetwarzanie tekstu w potoku (pipe).
.br 
.I Przykad:
.TP
.BR "type joke1.txt | cpl 14- - >joke3.txt " (MSDOS)
Plik 
.I joke1.txt
zostanie przepuszczony przez konwersj Mazovia -> ISO-Latin-2,
a koce linii zostan zamienione na mod uniksow. Wynik zostanie 
zapisany do pliku
.IR joke3.txt .
.PP
Zwr uwag na obecno dwch minusw w linii polece - kady peni inn
funkcj. Pierwszy, poczony z opisem konwersji ("14-"), wcza konwersj
zakocze linii. Drugi, samodzielny, wcza tryb filtru.
.TP
.BR "cat joke.txt1 joke2.txt | cpl 14- - >joke3.txt " (Unix)
Przyjmujc, e pliki 
.I joke.txt 
i
.I joke2.txt 
s napisane oryginalnie w Mazovii i pod MSDOSem, takie polecenie spowoduje 
poczenie obu plikw, konwersj caoci z Mazovii na ISO Latin 2, i przy
okazji z CR+LF -> NL, a nastpnie zapis do pliku 
.IR joke3.txt .
.PP
Uruchamiajc
.I ConvPL
w tym trybie naley uwaa na pomyki takie jak ta:
.TP
.B cpl A joke.txt >prn
Tekst zostanie przekonwertowany zgodnie z regu 13 (skrt "A"), ale na
drukark nie zostanie wysany, gdy
.I ConvPL
bdzie go zapisywa do pliku
.I joke.txt
a nie na standardowe wyjcie. W rzeczywistoci powysze (bdne)
polecenie oznacza:
.br
.B konwertuj plik joke.txt, zapisujc wynik pod t sam nazw,
za na drukark wysyaj wyjcie przez program
normalnie wyswietlane na ekranie, czyli komunikaty.
.PP
Polecenie ponisze spowoduje najprawdopodobniej uszkodzenie oryginalnego
pliku, wic naley si go wystrzega:
.TP
.BR "cpl A - <joke.txt >joke.txt " (obie nazwy takie same!)
Po prostu, system straci gow prbujc rwnoczenie czyta i pisa
do pliku, a ucierpi na tym tene plik.
.PP
.I Pamitajmy:
aby uruchomi ConvPL w trybie filtru, potok danych musi
przychodzi z stdin i wychodzi na stdout (a nie czciowo z pliku, czciowo
z potoku). Jeli nie wiesz o co chodzi, to poczytaj o potokach, filtrach oraz
roli symboli <, |, > itp. w poleceniach DOSa i Uniksa.

.SH UWAGI
Od wersji 2.01 istnieje moliwo wykonywania konwersji zakocze linii
bez zmiany standardu polskich znakw. Wystarczy jako standard rdowy
poda ASCII - "0" (do tej pory byo to niedopuszczalne), za jako drugi
parametr opcj konwersji zakocze linii "-" lub "=".  Drugi parametr,
podany zgodnie z konwencj i okrelajcy standard docelowy jest w tym
wypadku ignorowany. A zatem, kady z poniszych przykadw ma takie samo
dziaanie:
.TP
.B cpl  0- joke.txt
.TP
.B cpl 00- joke.txt
.TP
.B cpl 02- joke.txt
.PP
czyli konwersj zakocze linii do pojedynczych NL, bez naruszania
polskich liter.
.TP 
.B Komentarz do standardw
Za definicj Amiga PL dziekuj Marcinowi Kdzioce <2:484/15.16@fidonet>.
.IP
Definicje dodane w wersji 1.75 udostpni mi Edwin Wierszelis
<2:482/16@fidonet>, autor konwertera KPN.
.IP
.I Standard ASCII 
to oczywicie zwyke literki ASCII, zastpujce odpowiednie
polskie znaki. Taki tekst zwie si zwykle "polskawym", a standard okrela
jako CP473 (oryginalna, amerykaska strona kodowa).
.IP
.I FidoMazovia 
jest pformalnym (jak caa reszta ;) standardem, przyjtym 
w rodowisku sieci Fido. Jedyna rnica w stosunku do klasycznej Mazovii
to zamiana znaku c' (141) na c-cedilla (135), wynikajca ze wzgldw
technicznych.
.IP
.I Standard IBM Latin 2 (CP852) 
jest lansowany przez Micro$oft wraz z systemem
MSDOS. Wraz z kolejnym "systemem" - Windows wyszed na wiat standard
strony kodowej 1250 (CP1250). Znany te jako Windows-EE, czyli strona
kodowa dla Europy Wschodniej.
.IP
.I ISO-8859-2 
znany te jako 
.I ISO Latin 2 
jest standardem rozpowszechnionym
zwaszcza w systemach uniksowych i pracujcych pod X-window. Jest rwnie
standardem zalecanym przez Polskie Normy oraz uznanym za obowizujacy
w polskojzycznym WWW oraz w polskim UseNecie.
.IP
Standard 
.I FAT 
jest jednym z amigowskich dialektw, znalezionym w diskmagu
FAT przez Edwina Wierszelisa.
.IP
Standard
.I DHN
jest rozpowszechniony wraz z polskim ChiWriterem.
.IP
Niektre standardy pochodza z Polskiej Strony Ogonkowej 
.IR http://www.uci.agh.edu.pl/ogonki/ , 
na ktrej mona znale wiele cennych informacji na temat polskich liter.
.TP 
.B Konwersja tekstu Unix<->DOS:
Pod Uniksem kada linijka tekstu koczy si znakiem NL (new line) o kodzie
0xa, rwnoznacznym DOSowemu LF (line feed). Pod DOSem zakoczenie linii
stanowi para znakw CR+LF, czyli 0xd,0xa. Parametr "-" wymusza zakoczenie
linii znakiem NL, za "=" - par CR+LF. Brak okrelonego kierunku konwersji
nie spowoduje adnej zmiany kocw linii w pliku wynikowym. Parametry
konwersji zakocze linii dodaje si "na trzeciego" do parametrw konwersji
standardw.
.TP 
.B Kod rdowy
Program by z powodzeniem kompilowany Borlandem 3.1, gcc 2.7.2 pod Linuksem
(a.out, ELF), oraz DJGPP pod DOSem (gcc 2.6.3). Prosz o kontakt w razie 
wystpienia niekompatybilnoci kodu rdowego w innych systemach.
Wersja 2.04 i wysze s na razie kompilowalne tylko pod Linuksem (i by moe
innymi Uniksami).
.TP 
.B Licznik linii:
Typowy "wodotrysk". Zwalnia prac o ok. 30%. Standardowo wyczony, w celu
wczenia trzeba przekompilowa rda bez opcji NO_LINE_COUNT. Licznik jest
zawsze wyczony podczas pracy w trybie stdin/stdout (czyli zazwyczaj jako
filtr itp.).
.TP 
.B Znane bdy:
Tekst nie moe zawiera znaku ASCII 0 (^@), 
ktry jest uywany jako znacznik koca pliku.

.SH "INNE OPCJE"
.TP
.BR \-? ", " \-h ", " --help:
wywietlaj list wszystkich dostpnych parametrw, skadni linii polece
itp.
.TP
.BR \-V ", " --version:
wywietla (na stdout) numer wersji CPL
.TP
.BR \-L ", " --licencja:
wywietlaj licencj uytkowania programu.
.TP
.BR \-S ", " --standard:
wywietlaj tabelk wszystkich obsugiwanych standardw polskich znakw.
.\" .SH "W PLANACH"
.\" .sp
.\" .B 'spolszczanie' cyrylicy
.\" .sp
.\" .B kody wieloznakowe

.SH "ZOBACZ TAKE"
.BR qpl (7) 

.SH AUTORZY
.TP
.B Pawe Krawczyk 
\- wlaciciel praw autorskich programu
.B cpl
.br
.I <kravietz@pipeta.chemia.pk.edu.pl>
.TP
.B Mariusz Krawczyk
\- twrca pliku manual-a, czyli tego
.br
.I <scorpio@astra.mech.pk.edu.pl>
