.\" Copyright (c) 2002 Andrzej Krzysztofowicz
.\"
.TH QPL 7 "28 lutego 2002" "ConvPL"
.SH NAZWA
qpl \- rozpoznawanie standardw polskich znakw v2.03
.SH SKLADNIA
.B qpl
.RB [ - ]
.RI [ plik1.txt ]
.RI [ plik2.txt " ...]"
.RB [ -v | -b ]

.SH OPIS
Argumentami polecenia s nazwy plikw, ktrych standard kodowania ma
by rozpoznany. Ograniczeniem dla iloci nazw jest dugo linii
polece i wielko pamici. Po nazwach plikw mog nastpowa trzy
opcjonalne argumenty:
.TP
.B -v
wywietlenie tabeli zgodnoci znakw, na podstawie ktrej wyznaczany jest
standard badanego tekstu
.TP
.B -b
podanie wyniku analizy w postaci parametru dla programu
.I ConvPL
\- cyfry lub litery; opcji tej mona uzy do automatycznego konwertowania
plikw o nieznanym standardzie, podstawiajac uzyskany znak do linii polece
.B cpl
jako standard rdowy; patrz dokumentacja
.IR ConvPL ;
opcja
.B -b
automatycznie wycza opcj
.BR -v ;
opcje
.BR -b " i " -v
s automatycznie wyczane, gdy badany ma by wicej ni jeden plik.
.PP
Podanie "-" zamiast nazwy pliku powoduje prac w trybie filtru \- dane bd
pobierane ze standardowego wejcia.

.SH ALGORYTM
Zasada dziaania jest nastpujca: zliczane s wszystkie wystpienia
wszystkich polskich znakw narodowych. Poniewa znaki powtarzaj si
w rnych standardach, kade znak jest zliczany oddzielnie dla kadego
ze standardw. Obecne w tekcie znaki o funkcji innej ni polskie litery
(np. ramki), ale wchodzce w skad ktrego ze standardw mog spowodowa
zafaszowanie wynikw zwykego zliczania. Dla uniknicia takich zmian
liczba wystpie kadego znaku jest mnoona przez przypisany znakowi
wspczynnik, odzwiercielajcy czsto jego wystpowania w przecitnym
polskim tekcie. Nastpnie wystpienia wszystkich znakw s sumowane
w obrbie standardw. Wygrywa standard o najwikszym wyniku \- czyli
najbardziej przypominajcy ten obecny w tekcie.
.PP
Tabel zlicze znakw wywietla opcja
.BR -v .
W ostatniej kolumnie znajduje
si suma kadego wiersza. Pozwala to na samodzielne ocenienie wynikw
zliczania w szczeglnie problematycznych przypadkach.

.SH UWAGI
.TP 3
1)
Winietka programu i wszystkie informacje s wywietlane na stderr,
dziki czemu s "niewidzialne" przy zrzucaniu wyjcia do pliku,
filtrowaniu itp. Tabela zgodnoci
.RB ( -v )
i wynik \- parametr dla
.I ConvPL
.RB ( -b )
s natomiast wywietlane na stdout (nigdy razem, bo jedno wyklucza drugie).
.TP 3
2)
.B qpl
jest rozprowadzany razem z konwerterem
.IR ConvPL .
Autor zdecydowa si na rozprowadzanie go w postaci odrbnego programu
z powodw praktycznych. Jako taki, moe on mie wiksze moliwoci, wicej
zastosowa i bogatsz lini polece. Wspprac midzy obydwoma programami
\- w celu np. automatyzacji konwersji mona bardzo atwo zapewni sobie za
pomoc skryptw (Unix) lub baczw (MSDOS/4DOS).
.TP 3
3)
Rozrnienie standardw DHN i Logic oraz FX i KWK jest trudne, bo skadaj
si one z tych samych znakw w innej kolejnoci. QPL zazwyczaj trafnie
rozpoznaje rnic w przypadku przecitnej dugoci tekstw, jednak w wyniku
podaje na wszelki wypadek obie moliwoci.
.TP 3
4)
Opcje
.BR -b " i " -v
s wyczane, jeli w linii polece wystpuje wicej ni jeden plik.
Ponadto opcje
.BR -b " i " -v
wykluczaj si nawzajem
.TP 3
5)
Autor nie ksztaci si na kierunku majcym cokolwiek wsplnego z informatyk,
a oba algorytmy sam sobie wykombinowa. W zwizku z tym przyjmuje kady
zarzut o nieefektywno, brak oryginalnoci, poziom przedszkola itp. byle
na odpowiednim poziomie merytorycznym. ;)

.SH "ZOBACZ TAKE"
.BR cpl (7)

.SH AUTOR
.B Pawe Krawczyk
\- wlaciciel praw autorskich programu
.B qpl
.br
.I <kravietz@pipeta.chemia.pk.edu.pl>
